<ion-card>
  <ion-card-content class="table-container ion-no-padding">
    <div class="loading-shade" *ngIf="dataSource.loading$ | async">
      <mat-progress-bar
        *ngIf="dataSource.loading$ | async"
        mode="indeterminate"
      ></mat-progress-bar>
    </div>
    <div class="search-models">
      <mat-form-field class="full-width">
        <input
          matInput
          placeholder="Search"
          [(ngModel)]="search"
          (keyup.enter)="setFilter()"
        />
        <button mat-button matSuffix (click)="setFilter()">
          <mat-icon>search</mat-icon>
        </button>
      </mat-form-field>
    </div>

    <table
      mat-table
      class="full-width-table"
      [dataSource]="dataSource"
      matSort
      style="width: 100%;"
    >
      <!-- serial_no Column -->
      <ng-container matColumnDef="serial_no">
        <th
          mat-header-cell
          *matHeaderCellDef
          mat-sort-header
          (click)="setFilter()"
        >
          serial_no
        </th>
        <td mat-cell *matCellDef="let row">
          {{ row.serial_no }}
        </td>
      </ng-container>

      <ng-container matColumnDef="item_code">
        <th
          mat-header-cell
          *matHeaderCellDef
          mat-sort-header
          (click)="setFilter()"
        >
          item_code
        </th>
        <td mat-cell *matCellDef="let row">
          {{ row.item_code }}
        </td>
      </ng-container>

      <!-- UUID Column -->
      <ng-container matColumnDef="uuid">
        <th mat-header-cell *matHeaderCellDef>UUID</th>
        <td mat-cell *matCellDef="let row">{{ row.uuid }}</td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
    </table>

    <mat-card-actions>
      <mat-paginator
        #paginator
        class="mat-paginator-sticky"
        (page)="getUpdate($event)"
        [pageIndex]="paginator.pageIndex"
        [length]="dataSource.length"
        [pageSizeOptions]="[10, 50, 100, 500]"
      >
      </mat-paginator>
    </mat-card-actions>
  </ion-card-content>
</ion-card>
